{ ----------------------------------------------------------------------

  Copyright (c) 1997 by Martin Zahl
  eMail: Martin.Zahl@Informatik.uni-oldenburg.de

  The Idea of this component was to be able to save the configuration in the
  registry OR!! an inifile. So that you can select the destination without
  any changes in the source.
  I'm using the methods from TINIFile, because they have the same
  parameters as TRegistry "+ the Section-Field".
  So you can use the same method for both: TINIFile and TRegistry
  ---------------------------------------------------------------------- }

unit MyRegistry;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Registry, INIFiles;

type
  HKeys = (kHKEY_CLASSES_ROOT, kHKEY_CURRENT_USER, kHKEY_LOCAL_MACHINE,
           kHKEY_USERS, kHKEY_CURRENT_CONFIG, kHKEY_DYN_DATA);

  TMyRegistry = class(TComponent)
  private
    { Private-Deklarationen }
    INI             : TINIFile;
    REG             : TRegistry;
    bCreateReg,                 // Create registry-string if not exist??
    ToINI,                      // (intern version)
    bSaveToINI      : boolean;  // INI or Registry ?
    sAbout,
    sVersion,
    sINIFile        : string;   // INI-Filename
    sRegString      : string;   // Registry path
    hRootKey        : HKeys;
    function GetRootKey:HKey;
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    // Read-Functions
    constructor Create(AOwner:TComponent); override;
    function ReadString  (Section:string;Ident:string;Default:string):string;
    function ReadInteger (Section:string;Ident:string;Default:Integer):Integer;
    function ReadBool    (Section:string;Ident:string;Default:Boolean):Boolean;
    // Write-Methods
    procedure WriteString  (Group:string;Ident:string;Value:string);
    procedure WriteInteger (Group:string;Ident:string;Value:integer);
    procedure WriteBool    (Group:string;Ident:string;Value:boolean);
    procedure DeleteKey    (Section:string;Ident:string);
    procedure Open;
    procedure Close;
    procedure StrDummy(str:string);
  published
    { Published-Deklarationen }
    property SaveToINI : boolean read bSaveToINI write bSaveToINI default False;
    property INIFile   : string read sINIFile write sINIFile;
    property RegPath   : string read sRegString write sRegString;
    property RootKey   : HKeys read hRootKey write hRootKey default kHKEY_LOCAL_MACHINE;
    property CanCreate : boolean read bCreateReg write bCreateReg default True;
    property Version   : string read sVersion write StrDummy;
    property eMail     : string read sAbout   write StrDummy;
  end;

procedure Register;

implementation
